import funcs
import plot_funcs
import sympy as sy
import numpy as np
import time
import sys
import examtemp as example
import redirection

start_time = time.time()
p = example.Example()
options_cmd = sys.argv[:]
show_figures = "--show-figures" in options_cmd or "-s" in options_cmd
no_save_figures = "--no-save-figures" in options_cmd or "-n" in options_cmd
save_figures = not no_save_figures
save_results = "--save-results" in options_cmd or "-r" in options_cmd
if save_results:
    redir_to_file = open(sys.argv[1] + ".res", "w")
    sys.stdout = redirection.Tee(sys.stdout, redir_to_file)
# print("show_figures=", show_figures)
# print("no_save_figures=", no_save_figures)
# print("save_results=", save_results)
# for i_states in p.states:
#     globals()[i_states] = sy.Symbol(i_states)
# l_parameters = list(p.parameters)
# print(l_parameters)
# for i_parameter in l_parameters:
#     globals()[i_parameter] = p.parameters[i_parameter]
sys_conf = p.system_config
sys_dis = p.system_display
dt = sys_conf["dt"]
w = sys_conf["w"]
initial_gap_epsilon = sys_conf["initial_gap_epsilon"]
number_periods = sys_conf["num_periods"]
num_system_simulations = sys_conf["num_system_simulations"]
auto_period_value = sys_conf["auto_period_value"]
one_period_fixed = sys_conf["period_value"]
init_system = sys_conf["init_system"]
print("Launch execution of", sys.argv[1])
print("dt=", dt)
print("w=", w)
print("initial_gap_epsilon=", initial_gap_epsilon)

system_equations_symb_dic = p.differential_system()
all_states_ = p.states
system_equations_symb = []
states_symb = []
all_states_symb = []
# sy.init_printing()
for i_eq_sys_ in range(0, len(all_states_)):
    all_states_symb.append(sy.Symbol(all_states_[i_eq_sys_]))
    if all_states_[i_eq_sys_] in system_equations_symb_dic:
        states_symb.append(sy.Symbol(all_states_[i_eq_sys_]))
        system_equations_symb.append(system_equations_symb_dic[all_states_[i_eq_sys_]])

print("states=", states_symb)
print("parameters=", p.parameters)
print("system_equations=", system_equations_symb)
# system_equations_symb, states_symb, l_guard, l_reset = system_eq_symb()
bool_guard = False
states_name = funcs.get_states_name_string(states_symb)
# print("states_name=", states_name)
sys_dis = p.system_display
system_equations = funcs.system_eq_func(system_equations_symb, states_symb)
jacob_matrix_sys = funcs.Jacobian_matrix(system_equations_symb, states_symb)

y = 2*states_symb[0]
# phi1 = 1
# phi1p = 1
# phi2 = 1
# phi2p = 2
# # delta = 1
# s = phi1, phi1p, phi2, phi2p
m = 0
try:
    m = p.guard_def(*all_states_symb)
except TypeError:
    bool_guard = True
if m is None:
    bool_guard = False
else:
    bool_guard = True
# print("bool_guard=", bool_guard)
if "reset" not in dir(p):
    bool_guard = False
else:
    if p.reset() is None or p.reset() == {}:
        bool_guard = False
# try:


if bool_guard:
    guard_equations = p.guard_def
    sys_reset_dic = p.reset()
    l_reset = []
    for i_eq_sys_ in range(0, len(states_name)):
        if states_name[i_eq_sys_] in sys_reset_dic:
            l_reset.append(sys_reset_dic[states_name[i_eq_sys_]])
        else:
            l_reset.append(None)
    print("Reset=", l_reset)
    reset_equations = funcs.system_eq_func(l_reset, states_symb)
else:
    guard_equations = None
    reset_equations = None
length_system = len(system_equations_symb)


# print("gauur=", guard_equations(-0.2/2, 0, -0.2, 0))
if auto_period_value:
    fp = funcs.find_period(init_system, 4, system_equations, dt, guard_equations, reset_equations)
    i_one_period = fp[0]
    one_period = i_one_period * dt
else:
    one_period = float(one_period_fixed)
    i_one_period = int(one_period / dt)
# init_system = fp[1]
# print("i_one_period=", i_one_period)
print("one period= ", one_period)
timeEnd = number_periods * one_period
NodeT = (i_one_period * number_periods) + 1
print("NodeT= ", NodeT)
# num_system_simu = 2
# period_inclus = 0
index_fig = 1
tf = timeEnd
system_orig = list(np.zeros((NodeT, length_system)))
system_min = list(np.zeros((NodeT, length_system)))
system_max = list(np.zeros((NodeT, length_system)))
# system_top_black = zeros((NodeT, length_system))
# system_bottom_black = zeros((NodeT, length_system))
system_orig[0] = np.array(init_system).astype(np.float64)
system_min[0] = np.array(init_system).astype(np.float64)
system_max[0] = np.array(init_system).astype(np.float64)
# system_top_black[0] = init_system
# system_bottom_black[0] = init_system
# system_all_black = zeros((8, NodeT, length_system))
null_w = [0] * NodeT
all_lambda = list(np.zeros(NodeT))

all_lambda[0] = funcs.lambda_h(jacob_matrix_sys, system_orig[0])

if guard_equations is None:
    for i in range(1, NodeT):
        system_orig[i] = funcs.euler_d_system_no_guard(system_orig[i - 1], system_equations, 0, dt)
        system_min[i] = funcs.euler_d_system_no_guard(system_min[i - 1], system_equations, -(w / 2), dt)
        system_max[i] = funcs.euler_d_system_no_guard(system_max[i - 1], system_equations, (w / 2), dt)
        lambda_i = funcs.lambda_h(jacob_matrix_sys, system_orig[i])
        all_lambda[i] = lambda_i
        # if -dt <= lambda_i <= dt:
        #     all_lambda[i] = 0
        # else:
        #     all_lambda[i] = lambda_i

    # print("i=", i)
else:
    for i in range(1, NodeT):
        system_orig[i] = funcs.euler_d_system(system_orig[i - 1], system_equations, 0, dt, guard_equations, reset_equations)
        system_min[i] = funcs.euler_d_system(system_min[i - 1], system_equations, -(w / 2), dt, guard_equations, reset_equations)
        system_max[i] = funcs.euler_d_system(system_max[i - 1], system_equations, (w / 2), dt, guard_equations, reset_equations)
        lambda_i = funcs.lambda_h(jacob_matrix_sys, system_orig[i])

        all_lambda[i] = lambda_i

all_delta, all_gamma, wall_tube_bottom, wall_tube_top = funcs.gamma_delta_wall(system_orig, system_max, system_min, all_lambda, NodeT, length_system, system_equations, w, guard_equations, reset_equations, initial_gap_epsilon, dt)
print_check_inclusion, i_inclusion = funcs.inclusion_check(number_periods, i_one_period, wall_tube_bottom, wall_tube_top, length_system, all_lambda, all_delta, system_orig, initial_gap_epsilon, states_name, dt)
period_inclus = i_inclusion - 1
print_check_wall, i_min_wall_top, i_max_wall_bottom, min_wall_top, max_wall_bottom = funcs.min_wall_top_max_wall_bottom_check(length_system, i_one_period, wall_tube_top, wall_tube_bottom, period_inclus, states_name)
print_check_lambda_sign = funcs.sum_lambda_sign_check(all_lambda, number_periods, i_one_period)
print(print_check_inclusion)
print(print_check_wall)
print(print_check_lambda_sign)
print("Execution time: %s seconds ---" % (time.time() - start_time))
plot_funcs.display_plots(system_orig, all_lambda, all_gamma, all_delta, wall_tube_top, wall_tube_bottom, NodeT, dt,
                         tf, w, initial_gap_epsilon, length_system, system_equations, guard_equations, reset_equations,
                         init_system, num_system_simulations, period_inclus, i_one_period, states_name, index_fig, sys_dis, i_min_wall_top, i_max_wall_bottom, min_wall_top, max_wall_bottom, sys.argv[1], show_figures, save_figures)

if save_results:
    redir_to_file.close()
# print("m=", m)
